var server, lastResp, engines = { up: false, left: false, right: false };

function start(callback) {
	step(null, null, callback);
}

function step(id, engines, callback) {
	var url = "http://" + server + "/";

	if(id) {
		url += "stav?id=" + id + "&nahoru=" + (+engines.up) + "&doleva=" + (+engines.left) + "&doprava=" + (+engines.right);
	} else
		url += "start";

	var ts = Date.now();

	httpGet(url, function(data) {
		data = data.trim().split("\r\n");

		if(data.length === 1)
			return callback(data[0]);

		data[1] = data[1].split(" ");
		data[2] = data[2].split(" ");
		data[4] = data[4].split(" ");

		lastResp = {
			id: parseInt(data[0], 10),
			x: parseFloat(data[1][0]),
			y: parseFloat(data[1][1]),
			vx: parseFloat(data[2][0]),
			vy: parseFloat(data[2][1]),
			p: parseFloat(data[3]),
			l: parseFloat(data[4][0]),
			r: parseFloat(data[4][1]),
			timestamp: ts
		};

		callback();
	});
}

function getState(initial, engines, delta) {
	return {
		x: initial.x + initial.vx * delta + 0.5 * (6 * engines.right - 6 * engines.left) * delta * delta,
		y: initial.y + initial.vy * delta + 0.5 * (-7 + 12 * engines.up) * delta * delta,
		vx: initial.vx + (6 * engines.right - 6 * engines.left) * delta,
		vy: initial.vy + (-7 + 12 * engines.up) * delta,
		p: initial.p - (0.5 * engines.left + 0.5 * engines.right + 1 * engines.up) * delta
	};
}

function isLandingSuccessful(state) {
	return state.y <= 10 && state.p >= 0 && Math.abs(state.vy) <= 5 && Math.abs(state.vx) <= 5;
}
